<ng-container [ngSwitch]="question.type" *ngIf="!!question && !!control">
  <form-input
    [control]="control"
    [label]="question.body"
    [hint]="question.hint"
    type="text"
    *ngSwitchCase="'text'"
  ></form-input>

  <form-text
    [control]="control"
    [label]="question.body"
    [hint]="question.hint"
    *ngSwitchCase="'textarea'"
  ></form-text>

  <form-textarea
    [control]="control"
    [label]="question.body"
    [hint]="question.hint"
    *ngSwitchCase="'plainTextarea'"
  ></form-textarea>

  <form-email
    [control]="control"
    [label]="question.body"
    [hint]="question.hint"
    *ngSwitchCase="'email'"
  ></form-email>

  <form-number
    [control]="control"
    [label]="question.body"
    [hint]="question.hint"
    *ngSwitchCase="'number'"
  ></form-number>

  <form-phone
    [control]="control"
    [label]="question.body"
    [hint]="question.hint"
    *ngSwitchCase="'phone'">
  </form-phone>

  <form-datepicker
    [control]="control"
    [label]="question.body"
    [hint]="question.hint"
    [datepickerOptions]="datepickerOptions"
    *ngSwitchCase="'date'"
  ></form-datepicker>

  <form-timepicker
    [control]="control"
    [label]="question.body"
    [hint]="question.hint"
    *ngSwitchCase="'time'"
  ></form-timepicker>

  <form-select
    [control]="control"
    [label]="question.body"
    [hint]="question.hint"
    [placeholder]="question.placeholder"
    [data]="question.values"
    [multiple]="question.multiple"
    *ngSwitchCase="'select'"
  ></form-select>

  <form-select-dialog
    [control]="control"
    [label]="question.body"
    [hint]="question.hint"
    [data]="question.values"
    *ngSwitchCase="'selectDialog'"
  ></form-select-dialog>

  <form-radio
    [control]="control"
    [label]="question.body"
    [hint]="question.hint"
    [data]="question.values"
    *ngSwitchCase="'radio'"
  ></form-radio>

  <form-checkbox
    [control]="control"
    [label]="question.body"
    [hint]="question.hint"
    [data]="question.values"
    [multiple]="question.multiple"
    *ngSwitchCase="'checkbox'"
  ></form-checkbox>

  <form-range
    [control]="control"
    [label]="question.body"
    [hint]="question.hint"
    [from]="question.from"
    [to]="question.to"
    [step]="question.step"
    [fromLabel]="question.from_label"
    [toLabel]="question.to_label"
    *ngSwitchCase="'range'"
  ></form-range>

  <form-switch
    [control]="control"
    [label]="question.body"
    [hint]="question.hint"
    *ngSwitchCase="'switch'"
  ></form-switch>

  <form-upload
    [control]="control"
    [label]="question.body"
    [hint]="question.hint"
    [multiple]="question.multiple"
    *ngSwitchCase="'upload'"
  ></form-upload>

  <form-location
    [group]="control"
    [label]="question.body"
    [hint]="question.hint"
    [showMap]="question.displayMap"
    [showStreetView]="question.displayStreetView"
    [captureStreetView]="question.captureStreetView"
    [showMarker]="question.showMarker"
    [showLocationFinder]="question.showLocationFinder"
    *ngSwitchCase="'location'"
  ></form-location>

  <form-address-lookup
    [group]="control"
    [label]="question.body"
    [hint]="question.hint"
    *ngSwitchCase="'addressLookup'"
  ></form-address-lookup>

  <form-select
    [control]="control"
    [label]="question.body"
    [hint]="question.hint"
    [data]="question.values"
    *ngSwitchCase="'partyType'"
  ></form-select>

  <form-vehicle-type
    [group]="control"
    [label]="question.body"
    [hint]="question.hint"
    [data]="question.values"
    *ngSwitchCase="'vehicleType'"
  ></form-vehicle-type>

  <form-incident-type
    [group]="control"
    [label]="question.body"
    [hint]="question.hint"
    [placeholder]="question.placeholder"
    [data]="question.values"
    *ngSwitchCase="'incidentType'"
  ></form-incident-type>

  <form-vrn-lookup
    [group]="control"
    [label]="question.body"
    [hint]="question.hint"
    [includeVrn]="question.includeVrn"
    *ngSwitchCase="'vrnLookup'"
  ></form-vrn-lookup>

  <form-vehicle-selector
    [group]="control"
    [label]="question.body"
    [hint]="question.hint"
    *ngSwitchCase="'vehicleSelector'"
  ></form-vehicle-selector>

  <form-damage-selector
    [control]="control"
    [label]="question.body"
    [hint]="question.hint"
    [image]="question.image"
    *ngSwitchCase="'damageSelector'"
  ></form-damage-selector>

  <div
    class="control-helper-text"
    [innerHTML]="question.body | safeHtml"
    *ngSwitchCase="'helperText'"
  ></div>
</ng-container>
